function ML=ML_rulkov(time_x,f1)
global N inSize outSize testLen 
alpha=0.09;                 % leakage constant
sigma=1;    
initLen = 0;               %% transient for training
trainLen =25000;            %% length for training
testLen =10000;             %% length for testing
density =0.25;              %% for sparse matrix
%%%%%%%%%%%%%%%%%%%%%%%%%%%%two node feed%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%inSize =1;               %% no of input variable here 
outSize = N-inSize;               %%  no of output variable here
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
resSize =1000;                          % size of the reservoir nodes;
Win=(rand(resSize,1+inSize)-0.5).*1;    % input weight
%W=rand(resSize,resSize)-0.5;            %reservoir matrix  
W=sprand(resSize,resSize,density);
a=(find(W~=0));
W(a)=-1+2*W(a);

%% training data as per the requirement

Y_l1=time_x(end-(trainLen+testLen):end,:);
indata=Y_l1(initLen+1:initLen+trainLen+testLen+1,f1); 
outdata=Y_l1(initLen+1:initLen+trainLen+testLen+1,setdiff(1:N,f1));

% % % % %% spectral radius calculation
disp 'Computing spectral radius...';
opt.disp = 0;                           % scaling   
rhoW = abs(eigs(W,1,'LM',opt));
W = W.*(0.95/rhoW);
% % % % % W = W.*(1.23/rhoW);
while any(isnan(W(:)))
%W=rand(resSize,resSize)-0.5;  %%% if any element of W is NAN
W=sprand(resSize,resSize,density);
a=(find(W~=0));
W(a)=-1+2*W(a);
rhoW = abs(eigs(W,1,'LM',opt));
W = W.*(0.95/rhoW);
end
        
X = zeros(1+inSize+resSize,trainLen-initLen);     
Yt = outdata(initLen+1:initLen+trainLen,:)';   

% % % % % run the reservoir with the data and collect X
x = zeros(resSize,1);          %train the machine
for t = 1:trainLen 


u = indata(t,:)';
x = (1-alpha)*x+alpha*tanh(Win*[1;u]+sigma*W*x);
if t > initLen
      X(:,t-initLen) = [1;u;x];
end
end

% % % % % train the output
reg = 1e-6;  % regularization coefficient
%reg=0;
X_T = X';
Wout = Yt*X_T/(X*X_T + reg*eye(1+inSize+resSize));

Y1= zeros(outSize,testLen);
u = indata(trainLen+1,:)'; 

for t = 1:testLen 
  
    x = (1-alpha)*x+alpha*tanh(Win*[1;u]+sigma*W*x );
    y = Wout*[1;u;x];
    Y1(:,t) = y;
    % generative mode:
     %u = y;
    % this would be a predictive mode:
    u = indata(trainLen+t+1,:)';   %%% we give data for testing coutries for testing not the targeted country
end

for jj=1:outSize
Y1_data(jj,:)=outdata(trainLen+1:trainLen+testLen,jj);
Y1_machine(jj,:)= Y1(jj,:);
end
ML=[Y1_data' Y1_machine'];

% plot(Y1_data(1,:));
% hold on
% plot(Y1_data(2,:));
% plot(Y1_machine(1,:))
