clear all;
clc;

global N inSize outSize testLen C
inSize=5;   
iteration=5;   % number of iteration and inputs
N=500;%k=10;p_intra=0.2;C=small1(N,k,p_intra);
tf=60000;
ntrans=20000;
sigma=0.003;
beta=-1.5;
epsilon=0:0.002:0.12;
alpha1=4.1+(4.4-4.1)*rand(N,1);
summ1=zeros(length(epsilon),1);
summ2=zeros(length(epsilon),1);
R_original=zeros(length(epsilon),1); 
R_machine=zeros(length(epsilon),1);
rmse=zeros(length(epsilon),1);
RE=zeros(length(epsilon),1);

%% adjacency matrix
%load('500_coupling_sw_average10.mat')
% load('coupling_matrix_final500_assor0.2.mat');
%  load('coupling_matrix_final500_assor0.1.mat');
%load('coupling_matrix_final500_assor0.3averagedgree14.mat');
%load('coupling_matrix_final500_assor-0.3.mat');
load('coupling_matrix_final500_assor0.mat');
%load('coupling_matrix_final500_assor-0.2.mat'); 
%load('coupling_matrix_final500_assor0.35.mat');
%C=A1;
%C=scalefree_assort(C,0.3,N);


for iter=1:iteration
iter
f1=randperm(N,inSize);     %for random selection

%% system evaluation
 for d=1:length(epsilon)

fx=zeros(N,1);fy=zeros(N,1);
time_x=zeros(tf-ntrans,N);
time_y=zeros(tf-ntrans,N);

x=rand(N,1);y=rand(N,1);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 %ep=epsilon(d)
 ep=epsilon(d)./sum(C');
for t=1:tf

 fx=alpha1./(1+x.^2)+y+ep'.*(C*x-x.*sum(C')');
 fy=y-sigma*(x-beta);

 x=fx;
 y=fy;
if t>ntrans
    time_x(t-ntrans,:)=x;
    time_y(t-ntrans,:)=y; 
end
end
 
time_x1=ML_rulkov(time_x,f1);   %function
 
mini=zeros(2*outSize,1);maxi=zeros(2*outSize,1);

for u=1:2*outSize  
   bb=[];burst=[];
    x1=time_x1(:,u);

 for t=1:testLen-1               %time should be in 
     if (x1(t)+1)<0 && (x1(t+1)+1)>0
         if abs(x1(t)+1)<abs(x1(t)+1)   % for chialvo map
             bb=[bb,t];
         else
             bb=[bb,t+1];
         end
     end
 end
 for t=1:length(bb)          %taking the values of burst after first 1000 points
    if bb(t)>100           
    if x1(bb(t)-60:bb(t)-1)<-1  %% 60 time point before each burst                                             %takes value greater than -0.5
        burst=[burst,bb(t)];     
    end
    end
end

    
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
     
%burst=ntrans+burst;

mini(u)=min(burst); maxi(u)=max(burst);
maxx{u}=burst;

end

MM=max(mini);
NN=min(maxi);
time=MM:NN;

phi=zeros(length(time),2*outSize);

for u=1:2*outSize   
h=maxx{u};
for v=1:length(h)
    if time(1)>=h(v)   %%from where to start calculation
       p1=v; 
    end
end


for v=length(h):-1:1
    if time(end)<=h(v)
        p2=v;
    end
end


b=h(p1:p2);
p=2;
     for t=1:1:length(time)
         if time(t)<=b(p)
          phi(t,u)=2*pi*(time(t)-b(p-1))/(b(p)-b(p-1));
         else
             p=p+1;
          phi(t,u)=2*pi*(time(t)-b(p-1))/(b(p)-b(p-1));
         end
   
     end 
end

exp_phi=exp(i.*phi);   %e^(iphi)


final_r1=zeros(length(time),1);   
r1=zeros(length(time),1);
final_r2=zeros(length(time),1);   
r2=zeros(length(time),1);



    for t=1:length(time)
        final_r1(t)=sum(exp_phi(t,1:outSize))/outSize;   %original (sum over nodes)
        final_r2(t)=sum(exp_phi(t,outSize+1:end))/outSize;   %machine generated 
        r1(t)=sqrt((real(final_r1(t)))^2+(imag(final_r1(t)))^2);  %original r(t)
        r2(t)=sqrt((real(final_r2(t)))^2+(imag(final_r2(t)))^2);  % machine r(t)
    end  
rmse(d)=sqrt(sum((r1(end-5000+1:end)-r2(end-5000+1:end)).^2)/5000);  %rmse
summ1(d)=sum(r1)/(length(time));    % R original
summ2(d)=sum(r2)/(length(time));    % R machine
 end
RE=RE+rmse;
R_original= R_original+summ1;
R_machine=R_machine+summ2;

end
R_original=R_original/iteration;
R_machine=R_machine/iteration;
RE=RE/iteration;


save('assort0_random5_original.mat','R_original')
save('assort0_random5_machine.mat','R_machine')
save('assort0_random5_rmse.mat','RE')

figure(1)
plot(epsilon,R_original,'o-','Linewidth',2)
hold on
plot(epsilon,R_machine,'ro-','Linewidth',2)

figure(2)
plot(epsilon,RE)
